#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;
int main()
{
    int N, K;
    scanf("%d%d", &N, &K);
    int a[N][N];
    int i, j, c, pom, pom1=0, pom2;
    int p, q, p1, q1, x, y, pogodne=0;

    for(i=0; i<N; i++)
        for(j=0; j<N; j++)
            scanf("%d", &a[i][j]);

    for(c=1; c<=K; c++){
        pom=0;
        pom1=0;
        for(i=0; i<N; i++){
            for(j=0; j<N; j++){
                if((a[i][j] == c) && (pom == 0)){
                    p=i;
                    q=j;
                    pom=1;
                }
                if(a[i][j] == c){
                    p1=i;
                    q1=j;
                    pom1++;
                }
            }
        }
        x = abs(p1-p);
        y = abs(q1-q);
        pom2= 2*x + 2*y;
        if(pom1 == 1)
            pogodne++;
        else if(pom2==pom1)
            pogodne++;
    }
    printf("%d", pogodne);
    return 0;
}